#include <stdio.h>
#include <conio.h>
#include <dos.h>


#define G_MODE13	0x13	/*modalit grafica 256 colori 320x200*/
#define G_TEXT		0x03	/*modalit testo 80x25*/
#define	MODE13_WIDTH	(unsigned int)320
#define	ROM_CHAR_WIDTH	8
#define	ROM_CHAR_HEIGHT	8

unsigned char far *video_buffer=(unsigned char far*)0xA0000000L;
unsigned char far *rom_char_set=(unsigned char far *)0xf000fa6el;

void Print_Char(int xc,int yc,char c,int color,int transparent);
void Graphics_Mode(int mode);
void Write_Pixel(int x,int y,int colore);
void scrivi(char *testo);

main()
{
int i,x=10;
clrscr();
printf("Programma che imposta la modalit grafica (320x200 a 256 colori),\n");
printf("disegna alcuni pixel e quindi imposta nuovamente la modalit di\ntesto (80x25).\n");
printf("Premi un tasto per continuare...");
getch();
Graphics_Mode(G_MODE13);
for(i=0;i<200;i++)Write_Pixel(x+i,20,2);
for(i=0;i<200;i++)Write_Pixel(x+i,30,i);
scrivi("...premi un tasto");
getch();
Graphics_Mode(G_TEXT);
printf("Realizzato da Andrea Nazzaro\n");
printf("Visita il sito http://web.tiscalinet.it/nazhome\n");
}

void Graphics_Mode(int mode)
{
union REGS inp,out;
inp.h.ah=0;
inp.h.al=(unsigned char)mode;
int86(0x10,&inp,&out);
}

void Write_Pixel(int x,int y,int color)
{
video_buffer[((y<<8)+(y<<6))+x]=(unsigned char)color;
}

void Print_Char(int xc,int yc,char c,int color,int transparent)
{
int offset,x,y;
unsigned char far *work_char;
unsigned char bit_mask;
work_char=rom_char_set+c*ROM_CHAR_HEIGHT;
offset=(yc<<8)+(yc<<6)+xc;
for(y=0;y<ROM_CHAR_HEIGHT;y++){
	bit_mask=0x80;
	for(x=0;x<ROM_CHAR_WIDTH;x++){
	if((*work_char&bit_mask))video_buffer[offset+x]=(unsigned char)color;
	else if(!transparent)video_buffer[offset+x]=0;
	bit_mask=(bit_mask>>1);
	}
offset+=MODE13_WIDTH;
work_char++;
}
}

void scrivi(char *testo)
{
int i=0,dim=8,x=20,y=100;
char c=testo[i];
while(c!='\0'){
		Print_Char(x,y,c,3,0);
		i++;
		x+=dim;
		c=testo[i];
		}
}